> ## Documentation Index
> Fetch the complete documentation index at: https://doc.lucidworks.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create/update/delete query rewrites

> A bulk CRUD endpoint for query rewrites.  The request body includes one or more `create`, `update`, or `delete` operations.  Use `/query-rewrite/instances` to get the configuration schemas for your existing query rewrites, or `/query-rewrite/schema` and `/query-rewrite/schema/{type}` to get the configuration schemas for the available query rewrite types.




>In the Fusion UI, some of these types correspond to the types in the Rewrites Manager and others correspond to actions in the Rules Manager.



## OpenAPI

````yaml /api-reference/5.9/fusion-api-query.json put /query-rewrite/instances
openapi: 3.0.1
info:
  title: Fusion Query API
  description: >-
    A Lucidworks Fusion microservice for machine-learning-enhanced ranking and
    retrieval.
  contact:
    name: Lucidworks
    url: www.lucidworks.com
    email: support@lucidworks.com
  license:
    name: License of API
    url: https://lucidworks.com/legal/developer-license-agreement/
  version: '5.9'
servers:
  - url: https://{FUSION HOST}/api
    description: Fusion
    variables:
      FUSION HOST:
        default: FUSION_HOST
        description: Your environment host.
  - url: https://{FUSION HOST}/api/apps/{APP_NAME}
    description: Fusion app
    variables:
      FUSION HOST:
        default: FUSION_HOST
        description: Your environment host.
      APP_NAME:
        default: APP_NAME
        description: The name of your Fusion app.
security:
  - Basic auth: []
  - API key: []
tags:
  - name: Custom Rule Type API
    description: Endpoints to define and manage custom rule type definitions.
  - name: Experiments API
    description: >-
      Use the Experiments API to compare different configuration variants and
      determine which ones are most successful.
  - name: Query Pipelines API
    description: >-
      Use these endpoints to view and manage your query pipelines.  You can also
      send queries using this API, though the Query Profiles API is recommended
      instead.
  - name: Query Profiles API
    description: >-
      The Query Profiles API provides static endpoints that you can consistently
      point to when querying your collections.  Query profiles allow you to
      change the query pipelines or collections behind them without changing the
      endpoint you use for your search queries.  See the Query Profiles CRUD API
      for endpoints that create and modify query profiles.
  - name: Query Profiles CRUD API
    description: >-
      Use these endpoints to create and modify query profiles.  Query profiles
      allow you to change the query pipelines or collections behind them without
      changing the endpoint you use for your search queries.  See the Query
      Profiles API for the query endpoints.
  - name: Query Rewrite API
    description: >-
      The Query Rewrite API manages documents used for query rewriting to
      improve relevancy using AI-generated data. Primarily for internal use.
  - name: Query Stage API
    description: >-
      Use these endpoints to view the available query pipeline stages and their
      configuration parameters.
  - name: Query Stage Plugins API
    description: >-
      Use these endpoints to view, install, and manage custom query stages
      developed with the Query Stage SDK.
  - name: Signal Indexing API
    description: Endpoints to index signals.
  - name: Experience Manager API
    description: API only for internal use by the Experience Manager Springboard system
  - name: Query Pipeline Template API
    description: Used internally to generate query pipelines from a template.
externalDocs:
  description: Lucidworks Documentation.
  url: https://doc.lucidworks.com/
paths:
  /query-rewrite/instances:
    put:
      tags:
        - Query Rewrite API
      summary: Create/update/delete query rewrites
      description: >-
        A bulk CRUD endpoint for query rewrites.  The request body includes one
        or more `create`, `update`, or `delete` operations.  Use
        `/query-rewrite/instances` to get the configuration schemas for your
        existing query rewrites, or `/query-rewrite/schema` and
        `/query-rewrite/schema/{type}` to get the configuration schemas for the
        available query rewrite types.





        >In the Fusion UI, some of these types correspond to the types in the
        Rewrites Manager and others correspond to actions in the Rules Manager.
      operationId: doBulkOperation
      parameters:
        - name: context
          description: >-
            The app to which this object belongs, as `app:SomeApp`. If the app
            doesn't exist, the request fails. Other comma-separated contexts in
            the `context` parameter are allowed but ignored.
          in: query
          required: true
          schema:
            type: string
          example: app:SomeApp
        - name: editSessionId
          description: >-
            The edit session ID associated with this request. Equivalent to a
            Fusion username.
          in: query
          required: false
          schema:
            type: string
        - name: checkUpdateConflict
          description: Whether to check for conflicts caused by this update.
          in: query
          required: false
          schema:
            type: boolean
            default: false
        - name: checkCreateConflict
          description: >-
            Whether to check for conflicts caused by creating this query
            rewrite.
          in: query
          required: false
          schema:
            type: boolean
            default: false
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BulkOperation'
        required: true
      responses:
        '200':
          description: OK
          content:
            application/octet-stream:
              schema:
                type: string
components:
  schemas:
    BulkOperation:
      type: object
      properties:
        delete:
          description: One or more query rewrites to delete.
          type: array
          items:
            type: string
        update:
          description: One or more query rewrites to update.
          type: array
          items:
            type: object
            additionalProperties:
              type: object
        create:
          description: One or more new query rewrites to create.
          type: array
          items:
            type: object
            additionalProperties:
              type: object
  securitySchemes:
    Basic auth:
      type: http
      scheme: basic
    API key:
      name: x-api-key
      type: apiKey
      in: header

````